// vector2.cpp		By: Aiman Hanna  1993 - 2004

// vector1.cpp illustrates how vectors can be traversed. An alternative traversal way 
// is to use an iterator pair to mark the beginning and end of the vector. An iterator 
// is a class object supporting the abstraction of a pointer type. In specific, iterator 
// is a typedef defined inside the vector class. 
// 
// The vector class provides two methods (begin() and end()) which return an iterator 
// to the beginning and end of the vector. 
//
// The program illustrates different ways. You should notice the output of traversing 
// vector v4 below. Can you explain the reason behind this output? 
//
//		Key Points: 1) The vector iterator

#include <iostream.h>

#include <vector> 
using namespace std;

int main()
{
	
	int Arr[7] = {0, 5, 10, 15, 20, 25, 30};
	vector<int> v1( Arr, Arr+5 );	// Initialize v1 to first 5 elements of Arr	
	vector<int> v2( Arr, Arr+7 );	// Initialize v2 to Arr
	vector<int> v3( Arr, Arr+7 );	// Initialize v3 to Arr
	vector<int> v4( Arr, Arr+7 );	// Initialize v4 to Arr
	vector<int> v5( Arr, Arr+7 );	// Initialize v5 to Arr
	
	vector<int>::iterator iter1 = v1.begin();

	vector<int>::iterator iter2;

	vector<int>::iterator iter3b = v3.begin(), iter3e = v3.end(); 

	vector<int>::iterator iter4b = v4.begin(), iter4e = v4.end(); 


	cout << "Contents of vector v1\n";
	cout << "=====================\n";
	cout << "Current size of v1 is: " << v1.size() << endl; 
	for ( iter1; iter1 != v1.end(); iter1++)
	{
		cout << *iter1 << "  ";
	}

	cout << "\n\nContents of vector v2\n";
	cout << "=====================\n";
	cout << "Current size of v2 is: " << v2.size() << endl; 
	for ( iter2 = v2.begin(); iter2 != v2.end(); iter2++)
	{
		cout << *iter2 << "  ";
	}


	cout << "\n\nContents of vector v3\n";
	cout << "=====================\n";
	cout << "Current size of v3 is: " << v3.size() << endl; 
	for ( ; iter3b < iter3e; )  
	{
		cout << *iter3b++ << "  ";
	}


	// Add 3 elements to v4. Where are the iterators pointing now????
	v4.push_back(35);
	v4.push_back(40);
	v4.push_back(45);

	cout << "\n\nContents of vector v4\n";
	cout << "=====================\n";
	cout << "Current size of v4 is: " << v4.size() << endl; 
	for ( iter4b; iter4b < iter4e; )
	{
		cout << *iter4b++ << "  ";
	}

	
	// Add 3 elements to v5. 
	v5.push_back(350);
	v5.push_back(400);
	v5.push_back(450);

	vector<int>::iterator iter5b = v5.begin(), iter5e = v5.end();
	cout << "\n\nContents of vector v5\n";
	cout << "=====================\n";
	cout << "Current size of v5 is: " << v5.size() << endl; 
	for ( iter5b; iter5b < iter5e; )
	{
		cout << *iter5b++ << "  ";
	}

	cout << endl;
	return(0);

}

/* The output
Contents of vector v1
=====================
Current size of v1 is: 5
0  5  10  15  20

Contents of vector v2
=====================
Current size of v2 is: 7
0  5  10  15  20  25  30

Contents of vector v3
=====================
Current size of v3 is: 7
0  5  10  15  20  25  30

Contents of vector v4
=====================
Current size of v4 is: 10
-572662307  -572662307  -572662307  -572662307  -572662307  -572662307  -572662307

Contents of vector v5
=====================
Current size of v5 is: 10
0  5  10  15  20  25  30  350  400  450
*/